# library of useful functions...
import random


def random_refill(a):
    for i in range(0, len(a)):
        a[i] = random.randint(0, 5*len(a))


def random_list(n):
    return [random.randint(0, 3 * n) for _ in range(0, n)]


def sorted_random_list(n):
    l = []
    v = random.randint(0, 5)
    for _ in range(0, n):
        l.append(v)
        v = v + random.randint(0, 5)
    return l


def sorted_random_list_v2(n):
    l = [random.randint(0, 5)]
    for i in range(1, n):  # OR for i in range(0,n-1)
        l.append(l[i - 1] + random.randint(0, 5))
    return l


# define this as a random walk...
def random_temperatures(n):
    if n == 0:
        return []
    min_temperature = -60
    max_temperature = 10
    daily_delta = 10
    t = [random.randint(min_temperature, max_temperature)]
    for i in range(1, n):
        t.append(t[i-1]+random.randint(-daily_delta, daily_delta))
        while t[i] not in range(min_temperature, max_temperature):
            t[i] = t[i - 1] + random.randint(-daily_delta, daily_delta)
    return t


# define this as a random walk...
def random_stock(n):
    if n == 0:
        return []
    min_value = 1
    daily_delta = 10
    t = [random.randint(min_value,100)]
    for i in range(1, n):
        t.append(t[i-1]+random.randint(-daily_delta, daily_delta))
        while t[i] <= 0:
            t[i] = t[i - 1] + random.randint(-daily_delta, daily_delta)
    return t


