# search for e in t, returning its position
# else None...
# elements in t can be in any order...

def naive_search_position_with_bounds(t, e, start, end):
    for i in range(start, end):
        if t[i] == e:
            return i  # position found!
    return None  # for all i, no position found!


def naive_search_position(t, e):
    return naive_search_position_with_bounds(t, e, 0, len(t))

# returns None if the element is not inside the array
# else returns one of its position
def dichotomic_search_position_with_bounds(t, x, begin, end):
    if end - begin == 1:  # base case
        if x == t[begin]:
            return begin
        return None
    # general case
    middle = (begin + end) // 2
    if x == t[middle]:  # exact position found!
        return middle
    if x < t[middle]:  # on the left...
        return dichotomic_search_position_with_bounds(t, x, begin, middle)
    return dichotomic_search_position_with_bounds(t, x, middle, end)


def dichotomic_search_position(a, e):
    return dichotomic_search_position_with_bounds(a, e, 0, len(a))


def search_minimum_position_with_bounds(a, start, end):
    comps = 0
    swaps = 0
    min_pos = start
    for i in range(start + 1, end):
        comps += 1
        if a[i] < a[min_pos]:
            min_pos = i
    return min_pos, comps, swaps


def search_minimum_position(a):
    return search_minimum_position_with_bounds(a, 0, len(a))


# find the position of an element in a sorted array
# returned position is the one the element
# could be inserted at
def dicho_find_pos(t, e, begin, end):
    if end-begin == 0:
        return begin, 0, 0
    if end-begin == 1:
        if t[begin] == e:
            return begin, 1, 0
        if t[begin] < e:
            return end, 2, 0
        return begin, 2, 0
    mid = (begin+end)//2
    if t[mid] > e:
        p, c, m = dicho_find_pos(t, e, begin, mid)
        return p, c+1, 0
    else:
        p, c, m = dicho_find_pos(t, e, mid, end)
        return p, c+1, 0
